{
   frmuCfg, configuration form
   Copyright (c) 2011. Dejan Boras

   This file is part of OpenArena Name Changer (oanc).

   domTrack is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   domTrack is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with domTrack. If not, see <http://www.gnu.org/licenses/>.

   Started On:    05.03.2011.
   Last Update:   09.03.2011.
}

{$MODE OBJFPC}{$H+}{$I-}
UNIT frmuCfg;

INTERFACE

USES
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  {oanc}
  uoanc;

TYPE
  { TfrmCfg }

  TfrmCfg = class(TForm)
     btnBrowse: TButton;
     btnOK: TButton;
     btnCancel: TButton;
     cbLocalCfg: TCheckBox;
     edFile: TEdit;
     lblOACfgFile: TLabel;
     dlgOpen: TOpenDialog;
     procedure btnBrowseClick(Sender: TObject);
     procedure btnCancelClick(Sender: TObject);
     procedure btnOKClick(Sender: TObject);
     procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

VAR
  frmCfg: TfrmCfg;

IMPLEMENTATION

{$R *.lfm}

{ TfrmCfg }

procedure TfrmCfg.btnBrowseClick(Sender: TObject);
begin
   if(dlgOpen.Execute()) then
      edFile.Text := dlgOpen.FileName;
end;

procedure TfrmCfg.btnCancelClick(Sender: TObject);
begin
   Close();
end;

procedure SetLocalConfig();
var
   f: file;
   fn: string;

begin
   localconfig := frmCfg.cbLocalCfg.Checked;

   fn := localcfgpath+lcfgFileName;
   system.Assign(f, fn);

   if(not localconfig) then begin
      erase(f);
   end else begin
      system.rewrite(f);
      system.close(f);
   end;
   IOResult();
end;

procedure TfrmCfg.btnOKClick(Sender: TObject);
var
   same: boolean;

begin
   same := (edFile.Text = oacfgfile);

   if(oaCfgFileExists(edFile.Text) or same) then begin
      SetLocalConfig();
      oaScanMods();

      oacfgfile := edFile.Text;
      Close();
   end else
      MessageDlg('Error', 'Cannot find the specified OA config file.',
         mtError, [mbOK], 0);
end;

procedure TfrmCfg.FormShow(Sender: TObject);
begin
   edFile.Text := oacfgfile;
   cbLocalCfg.Checked := localconfig;
end;

end.

