{
   frmuFav, favorites form
   Copyright (c) 2011. Dejan Boras

   This file is part of OpenArena Name Changer (oanc).

   domTrack is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   domTrack is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with domTrack. If not, see <http://www.gnu.org/licenses/>.

   Started On:    05.03.2011.
   Last Update:   07.03.2011.
}

{$MODE OBJFPC}{$H+}
UNIT frmuFav;

INTERFACE

USES
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, Grids,
  {uoanc}
  uoanc;

TYPE

  { TfrmFav }

  TfrmFav = class(TForm)
     btnSelect: TBitBtn;
     btnRemove: TBitBtn;
     btnCancel: TBitBtn;
     shpPrv: TShape;
     sgNames: TStringGrid;
     procedure btnCancelClick(Sender: TObject);
     procedure btnRemoveClick(Sender: TObject);
     procedure btnSelectClick(Sender: TObject);
     procedure FormCreate(Sender: TObject);
     procedure sgNamesSelection(Sender: TObject; aCol, aRow: Integer);
     procedure shpPrvPaint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

VAR
  frmFav: TfrmFav;

procedure AddToFav(const name: string);

IMPLEMENTATION

CONST
   SECTION_FAV = 'Favorites';
   SECTION_FAV_COUNT = 'Count';

{$R *.lfm}

{ TfrmFav }

procedure TfrmFav.btnCancelClick(Sender: TObject);
begin
   Close();
end;

procedure TfrmFav.btnRemoveClick(Sender: TObject);
var
   sel: longint;
   sg: TStringGrid;
   source: longint;

begin
   sg := frmFav.sgNames;
   sel := sg.Row;
   if(sel > 0) then begin
      source := sg.RowCount-1;

      if(sel <> source) then
         sg.Rows[sel].Assign(sg.Rows[source]);

      sg.RowCount := sg.Rowcount-1;
   end;
end;

procedure TfrmFav.btnSelectClick(Sender: TObject);
var
   sel: longint;

begin
   sel := frmFav.sgNames.Row;

   if(sel > 0) then begin
      playername := frmFav.sgNames.Rows[sel].Strings[0];
      Close();
   end else
      MessageDlg('Error', 'No name is selected.', mtWarning, [mbOK], 0);
end;

procedure TfrmFav.FormCreate(Sender: TObject);
begin
   sgNames.ColWidths[0] := sgNames.Width-4;
end;

procedure Preview();
var
   s: TStrings;
   sel: longint;

begin
   sel := frmFav.sgNames.Row;
   if(sel > 0) then begin
      {preview the name}
      s := frmFav.sgNames.Rows[sel];

      PreviewName(s.Strings[0], frmFav.shpPrv);
   end;
end;

procedure TfrmFav.sgNamesSelection(Sender: TObject; aCol, aRow: Integer);
begin
   frmFav.shpPrv.Invalidate();
   Preview();
end;

procedure TfrmFav.shpPrvPaint(Sender: TObject);
begin
   Preview();
end;

{ MANAGEMENT }

procedure AddToFav(const name: string);
var
  sl: TStringList;
  sg: TStringGrid;
  rc: longint;

begin
   sg := frmFav.sgNames;

   rc := sg.RowCount+1;
   sg.RowCount := rc;

   sl := TStringList.Create();
   sl.Add(name);

   sg.Rows[rc-1].Assign(sl);

   sl.Free();
end;

{ CONFIGURATION }
procedure LoadCfg();
var
   i, n: longint;
   ns, s: string;

begin
   n := iniCfg.ReadInteger(SECTION_FAV, SECTION_FAV_COUNT, 0);
   if(n > 0) then begin
      for i := 1 to n do begin
         str(i, ns);
         s := iniCfg.ReadString(SECTION_FAV, ns, '');
         if(s <> '') then
            AddToFav(s);
      end;
   end;
end;

procedure SaveCfg();
var
   sg: TStringGrid;
   n, i: longint;
   ns: string;

begin
   sg := frmFav.sgNames;
   n := sg.RowCount-1;

   iniCfg.WriteInteger(SECTION_FAV, SECTION_FAV_COUNT, n);

   if(n > 0) then begin
      for i := 1 to (n) do begin
         str(i, ns);
         iniCfg.WriteString(SECTION_FAV, ns, frmFav.sgNames.Rows[i].Strings[0]);
      end;
   end;
end;

INITIALIZATION
   LoadFavorites := @LoadCfg;
   SaveFavorites := @SaveCfg;
END.

