{
   frmuModSelect, mod selection form
   Copyright (c) 2011. Dejan Boras

   This file is part of OpenArena Name Changer (oanc).

   domTrack is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   domTrack is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with domTrack. If not, see <http://www.gnu.org/licenses/>.

   Started On:    07.03.2011.
   Last Update:   09.03.2011.
}

{$MODE OBJFPC}{$H+}
UNIT frmuModSelect;

INTERFACE

USES
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, CheckLst, StdCtrls,
  {oanc}
  uoanc;

type

  { TfrmModSelect }

  TfrmModSelect = class(TForm)
     btnSave: TBitBtn;
     btnCancel: TBitBtn;
     btnSelectAllNone: TBitBtn;
     clbMods: TCheckListBox;
     lblChoose: TLabel;
     procedure btnCancelClick(Sender: TObject);
     procedure btnSaveClick(Sender: TObject);
     procedure btnSelectAllNoneClick(Sender: TObject);
     procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

VAR
  frmModSelect: TfrmModSelect;

IMPLEMENTATION

{ TfrmModSelect }

VAR
   selectstate: boolean = true;

procedure select(s: boolean);
var
   clb: TCheckListBox;
   i: longint;

begin
   clb := frmModSelect.clbMods;

   if(clb.Items.Count > 0) then begin
      for i := 0 to (clb.Items.Count-1) do
         clb.Checked[i] := s;
   end;
end;

procedure SetSelectState();
begin
   case selectstate of
      true: begin
         frmModSelect.btnSelectAllNone.Caption := 'Select None';
         select(true);
      end;
      false: begin
         frmModSelect.btnSelectAllNone.Caption := 'Select All';
         select(false);
      end;
   end;
end;

procedure TfrmModSelect.btnSelectAllNoneClick(Sender: TObject);
begin
   selectstate := selectstate xor true;

   SetSelectState();
end;

procedure TfrmModSelect.btnCancelClick(Sender: TObject);
begin
   Close();
end;

procedure TfrmModSelect.btnSaveClick(Sender: TObject);
var
   i: longint;
   hasmods: boolean;
   save: boolean = false;

begin
   hasmods := oaHasMods();

   modlistsel.Clear();

   if(hasmods) then begin
      for i := 0 to (clbMods.Items.Count-1) do begin
         if(clbMods.Checked[0]) then
            modlistsel.Add(modlist[i]);
      end;

      if(modlistsel.Count > 0) then save := true;
   end else save := true;

   if(save) then begin
      oaSaveToMods();
      Close();
   end else
      MessageDlg('Error', 'No mods are selected.',
         mtInformation, [mbOK], 0);
end;

procedure TfrmModSelect.FormShow(Sender: TObject);
var
   hasmods: boolean = false;

begin
   {check if there are any mods}
   hasmods := oaHasMods();

   {add mods to the list}
   if(hasmods) then begin
      clbMods.Items.Clear();
      clbMods.Items.Assign(modlist);
      btnSelectAllNone.Enabled := true;
   end else begin
      clbMods.Items.Clear();
      clbMods.Items.Add('Selected config file');
      btnSelectAllNone.Enabled := false;
   end;

   {set state}
   selectstate := true;
   SetSelectState();
end;

INITIALIZATION
  {$I frmuModSelect.lrs}

END.

